#include "EsoAcsammm_Header.hpp"
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */
/* We do not support C11 <threads.h>.  */
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double par_u=0;
   double a1_par_u=0;
   double var_z1=0;
   double a1_var_z1=0;
   double der_var_z1=0;
   double a1_der_var_z1=0;
   double var_z2=0;
   double a1_var_z2=0;
   double der_var_z2=0;
   double a1_der_var_z2=0;
   double var_z3=0;
   double a1_var_z3=0;
   double der_var_z3=0;
   double a1_der_var_z3=0;
   double var_z4=0;
   double a1_var_z4=0;
   double der_var_z4=0;
   double a1_der_var_z4=0;
   double var_z5=0;
   double a1_var_z5=0;
   double der_var_z5=0;
   double a1_der_var_z5=0;
   double var_g1=0;
   double a1_var_g1=0;
   double der_var_g1=0;
   double a1_der_var_g1=0;
   double var_g2=0;
   double a1_var_g2=0;
   double der_var_g2=0;
   double a1_der_var_g2=0;
   double var_g3=0;
   double a1_var_g3=0;
   double der_var_g3=0;
   double a1_der_var_g3=0;
   double var_g4=0;
   double a1_var_g4=0;
   double der_var_g4=0;
   double a1_der_var_g4=0;
   double var_obj=0;
   double a1_var_obj=0;
   double der_var_obj=0;
   double a1_der_var_obj=0;
   double var_div0=0;
   double a1_var_div0=0;
   double var_div1=0;
   double a1_var_div1=0;
   double var_div2=0;
   double a1_var_div2=0;
   double var_div3=0;
   double a1_var_div3=0;
   double var_i_expr=0;
   double a1_var_i_expr=0;
   double var_div4=0;
   double a1_var_div4=0;
   double var_i_expr6=0;
   double a1_var_i_expr6=0;
   double var_div5=0;
   double a1_var_div5=0;
   double var_exp7=0;
   double a1_var_exp7=0;
   double var_i_expr8=0;
   double a1_var_i_expr8=0;
   double var_i_expr10=0;
   double a1_var_i_expr10=0;
   double var_div9=0;
   double a1_var_div9=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   double v1_6=0;
   double a1_v1_6=0;
   double v1_7=0;
   double a1_v1_7=0;
   double v1_8=0;
   double a1_v1_8=0;
   double v1_9=0;
   double a1_v1_9=0;
   double v1_10=0;
   double a1_v1_10=0;
   double v1_11=0;
   double a1_v1_11=0;
   double v1_12=0;
   double a1_v1_12=0;
   double v1_13=0;
   double a1_v1_13=0;
   double v1_14=0;
   double a1_v1_14=0;
   double v1_15=0;
   double a1_v1_15=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=par_u; acs_fds_c=acs_fds_c+1; par_u=p[0];
      acs_fds[acs_fds_c]=var_z1; acs_fds_c=acs_fds_c+1; var_z1=x[0];
      acs_fds[acs_fds_c]=der_var_z1; acs_fds_c=acs_fds_c+1; der_var_z1=der_x[0];
      acs_fds[acs_fds_c]=var_z2; acs_fds_c=acs_fds_c+1; var_z2=x[1];
      acs_fds[acs_fds_c]=der_var_z2; acs_fds_c=acs_fds_c+1; der_var_z2=der_x[1];
      acs_fds[acs_fds_c]=var_z3; acs_fds_c=acs_fds_c+1; var_z3=x[2];
      acs_fds[acs_fds_c]=der_var_z3; acs_fds_c=acs_fds_c+1; der_var_z3=der_x[2];
      acs_fds[acs_fds_c]=var_z4; acs_fds_c=acs_fds_c+1; var_z4=x[3];
      acs_fds[acs_fds_c]=der_var_z4; acs_fds_c=acs_fds_c+1; der_var_z4=der_x[3];
      acs_fds[acs_fds_c]=var_z5; acs_fds_c=acs_fds_c+1; var_z5=x[4];
      acs_fds[acs_fds_c]=der_var_z5; acs_fds_c=acs_fds_c+1; der_var_z5=der_x[4];
      acs_fds[acs_fds_c]=var_g1; acs_fds_c=acs_fds_c+1; var_g1=x[5];
      acs_fds[acs_fds_c]=der_var_g1; acs_fds_c=acs_fds_c+1; der_var_g1=der_x[5];
      acs_fds[acs_fds_c]=var_g2; acs_fds_c=acs_fds_c+1; var_g2=x[6];
      acs_fds[acs_fds_c]=der_var_g2; acs_fds_c=acs_fds_c+1; der_var_g2=der_x[6];
      acs_fds[acs_fds_c]=var_g3; acs_fds_c=acs_fds_c+1; var_g3=x[7];
      acs_fds[acs_fds_c]=der_var_g3; acs_fds_c=acs_fds_c+1; der_var_g3=der_x[7];
      acs_fds[acs_fds_c]=var_g4; acs_fds_c=acs_fds_c+1; var_g4=x[8];
      acs_fds[acs_fds_c]=der_var_g4; acs_fds_c=acs_fds_c+1; der_var_g4=der_x[8];
      acs_fds[acs_fds_c]=var_obj; acs_fds_c=acs_fds_c+1; var_obj=x[9];
      acs_fds[acs_fds_c]=der_var_obj; acs_fds_c=acs_fds_c+1; der_var_obj=der_x[9];
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div0,a1_var_div0);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_z1-(var_g1*(var_z2-var_z1)-var_div0*var_z1);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div1,a1_var_div1);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_z2-(var_g2*var_z3-var_div1*var_z2);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div2,a1_var_div2);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_z3-(var_g3*var_z3-var_div2*var_z3);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div3,a1_var_div3);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_z4-(0-7.3*var_g3*var_z3+var_div3*(20-var_z4));
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_z5-(par_u);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr; acs_fds_c=acs_fds_c+1; var_i_expr=(0.12+var_g3);
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_g3,a1_var_g3,var_i_expr,a1_var_i_expr,var_div4,a1_var_div4);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_g1-(4.75*var_div4);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr6; acs_fds_c=acs_fds_c+1; var_i_expr6=(0.1+var_z4);
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_z4,a1_var_z4,var_i_expr6,a1_var_i_expr6,var_div5,a1_var_div5);
      acs_fds[acs_fds_c]=var_i_expr8; acs_fds_c=acs_fds_c+1; var_i_expr8=0-5*var_z4;
      bmode_1=2; // store inputs and run original code
      a1_acs_exp(bmode_1,var_i_expr8,a1_var_i_expr8,var_exp7,a1_var_exp7);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_g2-(var_div5*var_exp7);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr10; acs_fds_c=acs_fds_c+1; var_i_expr10=((var_z4+0.4)*(var_z4+62.5));
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_z4,a1_var_z4,var_i_expr10,a1_var_i_expr10,var_div9,a1_var_div9);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_g3-(21.87*var_div9);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_g4-(58.75*var_g3*var_g3+1.71);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_obj-(0-var_z1*var_z5);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // For the case you need the actual function value at the end of the forward section, use this mode for storing it.
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
            acs_cs_c=acs_cs_c-1;
            if (acs_cs[acs_cs_c]==0) {
              acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_obj;
              v1_1=var_z1;
              v1_2=var_z5;
              v1_3=v1_1*v1_2;
              v1_4=-v1_3;
              v1_5=v1_4;
              v1_6=v1_0-v1_5;
              a1_v1_6=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_6; a1_v1_5=0-a1_v1_6;
              a1_v1_4=a1_v1_5;
              a1_v1_3=-a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_z5=a1_var_z5+a1_v1_2;
              a1_var_z1=a1_var_z1+a1_v1_1;
              a1_var_obj=a1_var_obj+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_g4;
              v1_1=58.75;
              v1_2=var_g3;
              v1_3=v1_1*v1_2;
              v1_4=var_g3;
              v1_5=v1_3*v1_4;
              v1_6=1.71;
              v1_7=v1_5+v1_6;
              v1_8=v1_7;
              v1_9=v1_0-v1_8;
              a1_v1_9=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_7=a1_v1_8;
              a1_v1_5=a1_v1_7; a1_v1_6=a1_v1_7;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_g3=a1_var_g3+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_g3=a1_var_g3+a1_v1_2;
              a1_var_g4=a1_var_g4+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_g3;
              v1_1=21.87;
              v1_2=var_div9;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_div9=a1_var_div9+a1_v1_2;
              a1_var_g3=a1_var_g3+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_z4,a1_var_z4,var_i_expr10,a1_var_i_expr10,var_div9,a1_var_div9);
              acs_fds_c=acs_fds_c-1; var_i_expr10=acs_fds[acs_fds_c];
              v1_0=var_z4;
              v1_1=0.4;
              v1_2=v1_0+v1_1;
              v1_3=v1_2;
              v1_4=var_z4;
              v1_5=62.5;
              v1_6=v1_4+v1_5;
              v1_7=v1_6;
              v1_8=v1_3*v1_7;
              v1_9=v1_8;
              a1_v1_9=a1_var_i_expr10; a1_var_i_expr10=0;
              a1_v1_8=a1_v1_9;
              a1_v1_3=v1_7*a1_v1_8; a1_v1_7=v1_3*a1_v1_8;
              a1_v1_6=a1_v1_7;
              a1_v1_4=a1_v1_6; a1_v1_5=a1_v1_6;
              a1_var_z4=a1_var_z4+a1_v1_4;
              a1_v1_2=a1_v1_3;
              a1_v1_0=a1_v1_2; a1_v1_1=a1_v1_2;
              a1_var_z4=a1_var_z4+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_g2;
              v1_1=var_div5;
              v1_2=var_exp7;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_exp7=a1_var_exp7+a1_v1_2;
              a1_var_div5=a1_var_div5+a1_v1_1;
              a1_var_g2=a1_var_g2+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_exp(bmode_1,var_i_expr8,a1_var_i_expr8,var_exp7,a1_var_exp7);
              acs_fds_c=acs_fds_c-1; var_i_expr8=acs_fds[acs_fds_c];
              v1_0=5;
              v1_1=var_z4;
              v1_2=v1_0*v1_1;
              v1_3=-v1_2;
              a1_v1_3=a1_var_i_expr8; a1_var_i_expr8=0;
              a1_v1_2=-a1_v1_3;
              a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
              a1_var_z4=a1_var_z4+a1_v1_1;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_z4,a1_var_z4,var_i_expr6,a1_var_i_expr6,var_div5,a1_var_div5);
              acs_fds_c=acs_fds_c-1; var_i_expr6=acs_fds[acs_fds_c];
              v1_0=0.1;
              v1_1=var_z4;
              v1_2=v1_0+v1_1;
              v1_3=v1_2;
              a1_v1_3=a1_var_i_expr6; a1_var_i_expr6=0;
              a1_v1_2=a1_v1_3;
              a1_v1_0=a1_v1_2; a1_v1_1=a1_v1_2;
              a1_var_z4=a1_var_z4+a1_v1_1;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_g1;
              v1_1=4.75;
              v1_2=var_div4;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_div4=a1_var_div4+a1_v1_2;
              a1_var_g1=a1_var_g1+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_g3,a1_var_g3,var_i_expr,a1_var_i_expr,var_div4,a1_var_div4);
              acs_fds_c=acs_fds_c-1; var_i_expr=acs_fds[acs_fds_c];
              v1_0=0.12;
              v1_1=var_g3;
              v1_2=v1_0+v1_1;
              v1_3=v1_2;
              a1_v1_3=a1_var_i_expr; a1_var_i_expr=0;
              a1_v1_2=a1_v1_3;
              a1_v1_0=a1_v1_2; a1_v1_1=a1_v1_2;
              a1_var_g3=a1_var_g3+a1_v1_1;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_z5;
              v1_1=par_u;
              v1_2=v1_1;
              v1_3=v1_0-v1_2;
              a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_v1_1=a1_v1_2;
              a1_par_u=a1_par_u+a1_v1_1;
              a1_der_var_z5=a1_der_var_z5+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_z4;
              v1_1=7.3;
              v1_2=var_g3;
              v1_3=v1_1*v1_2;
              v1_4=var_z3;
              v1_5=v1_3*v1_4;
              v1_6=-v1_5;
              v1_7=var_div3;
              v1_8=20;
              v1_9=var_z4;
              v1_10=v1_8-v1_9;
              v1_11=v1_10;
              v1_12=v1_7*v1_11;
              v1_13=v1_6+v1_12;
              v1_14=v1_13;
              v1_15=v1_0-v1_14;
              a1_v1_15=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_15; a1_v1_14=0-a1_v1_15;
              a1_v1_13=a1_v1_14;
              a1_v1_6=a1_v1_13; a1_v1_12=a1_v1_13;
              a1_v1_7=v1_11*a1_v1_12; a1_v1_11=v1_7*a1_v1_12;
              a1_v1_10=a1_v1_11;
              a1_v1_8=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_var_z4=a1_var_z4+a1_v1_9;
              a1_var_div3=a1_var_div3+a1_v1_7;
              a1_v1_5=-a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_z3=a1_var_z3+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_g3=a1_var_g3+a1_v1_2;
              a1_der_var_z4=a1_der_var_z4+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div3,a1_var_div3);
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_z3;
              v1_1=var_g3;
              v1_2=var_z3;
              v1_3=v1_1*v1_2;
              v1_4=var_div2;
              v1_5=var_z3;
              v1_6=v1_4*v1_5;
              v1_7=v1_3-v1_6;
              v1_8=v1_7;
              v1_9=v1_0-v1_8;
              a1_v1_9=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_7=a1_v1_8;
              a1_v1_3=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
              a1_var_z3=a1_var_z3+a1_v1_5;
              a1_var_div2=a1_var_div2+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_z3=a1_var_z3+a1_v1_2;
              a1_var_g3=a1_var_g3+a1_v1_1;
              a1_der_var_z3=a1_der_var_z3+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div2,a1_var_div2);
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_z2;
              v1_1=var_g2;
              v1_2=var_z3;
              v1_3=v1_1*v1_2;
              v1_4=var_div1;
              v1_5=var_z2;
              v1_6=v1_4*v1_5;
              v1_7=v1_3-v1_6;
              v1_8=v1_7;
              v1_9=v1_0-v1_8;
              a1_v1_9=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_7=a1_v1_8;
              a1_v1_3=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
              a1_var_z2=a1_var_z2+a1_v1_5;
              a1_var_div1=a1_var_div1+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_z3=a1_var_z3+a1_v1_2;
              a1_var_g2=a1_var_g2+a1_v1_1;
              a1_der_var_z2=a1_der_var_z2+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div1,a1_var_div1);
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_z1;
              v1_1=var_g1;
              v1_2=var_z2;
              v1_3=var_z1;
              v1_4=v1_2-v1_3;
              v1_5=v1_4;
              v1_6=v1_1*v1_5;
              v1_7=var_div0;
              v1_8=var_z1;
              v1_9=v1_7*v1_8;
              v1_10=v1_6-v1_9;
              v1_11=v1_10;
              v1_12=v1_0-v1_11;
              a1_v1_12=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_12; a1_v1_11=0-a1_v1_12;
              a1_v1_10=a1_v1_11;
              a1_v1_6=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_v1_7=v1_8*a1_v1_9; a1_v1_8=v1_7*a1_v1_9;
              a1_var_z1=a1_var_z1+a1_v1_8;
              a1_var_div0=a1_var_div0+a1_v1_7;
              a1_v1_1=v1_5*a1_v1_6; a1_v1_5=v1_1*a1_v1_6;
              a1_v1_4=a1_v1_5;
              a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
              a1_var_z1=a1_var_z1+a1_v1_3;
              a1_var_z2=a1_var_z2+a1_v1_2;
              a1_var_g1=a1_var_g1+a1_v1_1;
              a1_der_var_z1=a1_der_var_z1+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_u,a1_par_u,var_z5,a1_var_z5,var_div0,a1_var_div0);
              acs_fds_c=acs_fds_c-1; der_var_obj=acs_fds[acs_fds_c];
              v1_0=der_x[9];
              a1_v1_0=a1_der_var_obj; a1_der_var_obj=0;
              a1_der_x[9]=a1_der_x[9]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_obj=acs_fds[acs_fds_c];
              v1_0=x[9];
              a1_v1_0=a1_var_obj; a1_var_obj=0;
              a1_x[9]=a1_x[9]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_g4=acs_fds[acs_fds_c];
              v1_0=der_x[8];
              a1_v1_0=a1_der_var_g4; a1_der_var_g4=0;
              a1_der_x[8]=a1_der_x[8]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_g4=acs_fds[acs_fds_c];
              v1_0=x[8];
              a1_v1_0=a1_var_g4; a1_var_g4=0;
              a1_x[8]=a1_x[8]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_g3=acs_fds[acs_fds_c];
              v1_0=der_x[7];
              a1_v1_0=a1_der_var_g3; a1_der_var_g3=0;
              a1_der_x[7]=a1_der_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_g3=acs_fds[acs_fds_c];
              v1_0=x[7];
              a1_v1_0=a1_var_g3; a1_var_g3=0;
              a1_x[7]=a1_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_g2=acs_fds[acs_fds_c];
              v1_0=der_x[6];
              a1_v1_0=a1_der_var_g2; a1_der_var_g2=0;
              a1_der_x[6]=a1_der_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_g2=acs_fds[acs_fds_c];
              v1_0=x[6];
              a1_v1_0=a1_var_g2; a1_var_g2=0;
              a1_x[6]=a1_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_g1=acs_fds[acs_fds_c];
              v1_0=der_x[5];
              a1_v1_0=a1_der_var_g1; a1_der_var_g1=0;
              a1_der_x[5]=a1_der_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_g1=acs_fds[acs_fds_c];
              v1_0=x[5];
              a1_v1_0=a1_var_g1; a1_var_g1=0;
              a1_x[5]=a1_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z5=acs_fds[acs_fds_c];
              v1_0=der_x[4];
              a1_v1_0=a1_der_var_z5; a1_der_var_z5=0;
              a1_der_x[4]=a1_der_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z5=acs_fds[acs_fds_c];
              v1_0=x[4];
              a1_v1_0=a1_var_z5; a1_var_z5=0;
              a1_x[4]=a1_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z4=acs_fds[acs_fds_c];
              v1_0=der_x[3];
              a1_v1_0=a1_der_var_z4; a1_der_var_z4=0;
              a1_der_x[3]=a1_der_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z4=acs_fds[acs_fds_c];
              v1_0=x[3];
              a1_v1_0=a1_var_z4; a1_var_z4=0;
              a1_x[3]=a1_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z3=acs_fds[acs_fds_c];
              v1_0=der_x[2];
              a1_v1_0=a1_der_var_z3; a1_der_var_z3=0;
              a1_der_x[2]=a1_der_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z3=acs_fds[acs_fds_c];
              v1_0=x[2];
              a1_v1_0=a1_var_z3; a1_var_z3=0;
              a1_x[2]=a1_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z2=acs_fds[acs_fds_c];
              v1_0=der_x[1];
              a1_v1_0=a1_der_var_z2; a1_der_var_z2=0;
              a1_der_x[1]=a1_der_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z2=acs_fds[acs_fds_c];
              v1_0=x[1];
              a1_v1_0=a1_var_z2; a1_var_z2=0;
              a1_x[1]=a1_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z1=acs_fds[acs_fds_c];
              v1_0=der_x[0];
              a1_v1_0=a1_der_var_z1; a1_der_var_z1=0;
              a1_der_x[0]=a1_der_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z1=acs_fds[acs_fds_c];
              v1_0=x[0];
              a1_v1_0=a1_var_z1; a1_var_z1=0;
              a1_x[0]=a1_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_u=acs_fds[acs_fds_c];
              v1_0=p[0];
              a1_v1_0=a1_par_u; a1_par_u=0;
              a1_p[0]=a1_p[0]+a1_v1_0;
            }
          }
       }
       if (bmode_1==2) {
          res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
       }
}
